# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['GlobalEnvironmentArgs', 'GlobalEnvironment']

@pulumi.input_type
class GlobalEnvironmentArgs:
    def __init__(__self__, *,
                 name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a GlobalEnvironment resource.
        :param pulumi.Input[str] name: Name must start with a letter and contain letters, digits and `-` character. The maximum length is 32 characters
        """
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name must start with a letter and contain letters, digits and `-` character. The maximum length is 32 characters
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


@pulumi.input_type
class _GlobalEnvironmentState:
    def __init__(__self__, *,
                 name: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering GlobalEnvironment resources.
        :param pulumi.Input[str] name: Name must start with a letter and contain letters, digits and `-` character. The maximum length is 32 characters
        """
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name must start with a letter and contain letters, digits and `-` character. The maximum length is 32 characters
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


class GlobalEnvironment(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a global environment resource. This can be used to create and manage global environment.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_artifactory as artifactory

        test_env = artifactory.GlobalEnvironment("test-env")
        ```

        ## Import

        ```sh
         $ pulumi import artifactory:index/globalEnvironment:GlobalEnvironment dev-env myenv
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] name: Name must start with a letter and contain letters, digits and `-` character. The maximum length is 32 characters
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[GlobalEnvironmentArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a global environment resource. This can be used to create and manage global environment.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_artifactory as artifactory

        test_env = artifactory.GlobalEnvironment("test-env")
        ```

        ## Import

        ```sh
         $ pulumi import artifactory:index/globalEnvironment:GlobalEnvironment dev-env myenv
        ```

        :param str resource_name: The name of the resource.
        :param GlobalEnvironmentArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(GlobalEnvironmentArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = GlobalEnvironmentArgs.__new__(GlobalEnvironmentArgs)

            __props__.__dict__["name"] = name
        super(GlobalEnvironment, __self__).__init__(
            'artifactory:index/globalEnvironment:GlobalEnvironment',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            name: Optional[pulumi.Input[str]] = None) -> 'GlobalEnvironment':
        """
        Get an existing GlobalEnvironment resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] name: Name must start with a letter and contain letters, digits and `-` character. The maximum length is 32 characters
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _GlobalEnvironmentState.__new__(_GlobalEnvironmentState)

        __props__.__dict__["name"] = name
        return GlobalEnvironment(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Name must start with a letter and contain letters, digits and `-` character. The maximum length is 32 characters
        """
        return pulumi.get(self, "name")

